/**
 * 最初の著者:: トゥイー
 * リポジトリ情報:: $Id: UnificationState.hpp 11 2011-05-14 02:11:18Z yutaka_at_home $
 * 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
 * ライセンス:: CPL(Common Public Licence)
 */

#ifndef _TOPS_UNIFICATION_STATE_HPP_
#define _TOPS_UNIFICATION_STATE_HPP_

#include "tops/UnificatedElements.hpp"

#include "tops/common/Printable.hpp"
#include "tops/value/Variables.hpp"

#include <boost/shared_ptr.hpp>

namespace tops {

	class WMElement;

	class UnificationState;
	typedef boost::shared_ptr<UnificationState> UnificationStatePtr;

	/**
	 * 単一化状態です。
	 *
	 * @author トゥイー
	 */
	class UnificationState : public Printable {
	private:
		UnificatedElements m_sources;
		Variables m_variables;

	public:
		UnificationState(const UnificatedElements& sources, const Variables& variables) :
		m_sources(sources), m_variables(variables) {
		}

	public:
		/**
		 * サイズを取得します。
		 */
		size_t size() const {
			return m_sources.size();
		}

		/**
		 *
		 */
		const UnificatedElements& getSource() const {
			return m_sources;
		}

		/**
		 * 単一化元となるワーキングメモリ要素を取得します。
		 */
		WMElement* operator[](size_t i) const;

		/**
		 * 単一化に使用した変数表を取得します。
		 */
		const Variables& getVariables() const {
			return m_variables;
		}

	public:
		/**
		 * ストリームに出力します。
		 */
		void print(std::ostream& stream) const;
	};

}  // namespace tops

#endif
